package com.tuigai.tuigai_tongcheng_api.config;

import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class RabbitMqConfig {

    /***************飞猪商旅回调mq*********************/
    public static final String TUI_GAI_ORDER_EXCHANGE_NAME = "t.traintuigai.order.exchange";
    //来单邮件回调更新报价队列
    public static final String TUI_GAI_ORDER_QUEUE_NAME = "new.traintuigai.order.queue";
    //来单邮件回调更新报价路由key
    public static final String TUI_GAI_ORDER_QUEUE_ROUTING_KEY = "new.traintuigai.order.queue.routingkey";

    // 声明 来单邮件回调更新报价 Exchange
    @Bean("trainslOrderExchange")
    public DirectExchange trainslOrderExchange() {
        return new DirectExchange(TUI_GAI_ORDER_EXCHANGE_NAME);
    }

    //申明 来单邮件回调更新报价队列
    @Bean("trainslOrderQueue")
    public Queue trainslOrderQueueName() {
        return new Queue(TUI_GAI_ORDER_QUEUE_NAME);
    }

    @Bean
    public Binding trainslorderExchangeBingding(@Qualifier("trainslOrderQueue") Queue queue,
                                                @Qualifier("trainslOrderExchange") DirectExchange exchange) {
        return BindingBuilder.bind(queue).to(exchange).with(TUI_GAI_ORDER_QUEUE_ROUTING_KEY);
    }

}

