package com.tuigai.tuigai_tongcheng_api.model;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;

import com.tuigai.tuigai_tongcheng_api.enums.ChangeTicketTypeEnum;
import com.tuigai.tuigai_tongcheng_api.utils.Utils;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

@Data
public class ChangeTrainOrder {
    public String id;
    public String orderId;
    public String outId;
    public String bizOrderId;
    public String orderStatus;//50--待改签  51--改签失败 52--改签成功
    public Integer companyId;
    public String orderSource;
    public String createTime;
    public String agentId;
    public String changeApplyId;
    public String changeFromDateTime;//change_from_station
    public String changeFromStation;//重庆西
    public String changeFromStationCode;//CXW
    public String changeIssueTimeout;//2023-01-05 12:00:00
    public String changeTicketType;//0
    public String changeToDateTime; //"2023-01-05 12:00:00";
    public String changeToStation;//成都东
    public String changeToStationCode;//ICW
    public String changeTrainCode;//G102
    public String changeTrainDate;//20230105
    public String changeType;//0改签类型 0:低改高 1:平改 2:高改低
    public String originalFromDateTime;//original_from_date_time
    public String originalFromStation;//重庆西
    public String originalFromStationCode;//CXW
    public String originalSequenceNo;//EJ123456789
    public String originalToDateTime;//original_to_date_time
    public String originalToStation;//成都东
    public String originalToStationCode;//ICW
    public String originalTrainCode;//G101
    public String originalTrainDate;//20230105
    public String settlementMode;//1
    public String status;//0
    public float ticketPriceAll;//100
    public String ticketTotalNum;//2
    public String tpId;//1779715812572607883
    public String ttpId;//4812850813378

    public int callBackStatus;//是否回调成功 0 失败 1成功
    public int callBackFailed;//
    public String operator;//订单操作人
    public String issueTime;//改签完成时间
    public String remark;//
    public int issueMinutes;//
    public float payPrice;//
    public float orderPrice;//
    public String alipayTradeNo;//支付宝交易流水号
    public String sequenceNo;//改签票12336订单号
    public String gudingNum;
    public String issueFailCode;//改签失败代码，已经存在MeituanUtil
    public String issueFailReason;//改签原因
    public String alipayAccount;//支付宝账号
    public String lockOrderTime;//锁单时间
    public String passengerNames;//
    public String originalSeatTypeName;//原票坐席类型名称
    public String originalSeatTypeCode;//原票坐席类型代码
    public String originalSeatNo;//原票坐席号
    public String originalTicketPrice;//原票票价(分)
    public String originaCoachNo;//原票车厢号
    public String originaCoachName;//原票车厢名称
    public String operators;
    //vo使用
    public int userId;
    public String userName;
    public String token;
    public String daigaiqianshichang;
    public int isJinjiChange;//是否紧急改签
    //public boolean isOverTime;//是否已过发车时间

    /**
     * 优先级排序字段 VO
     * 例 SHY 1  YSL 2   taobao 3
     */
    public int sorted;

    public Integer vipTicketNoSeatAccept;//接受无座 1接受 0不接受

    public Integer vipTicketNoSeat;//接受无座 1接受 0不接受

    public List<ChangeTrainOrderPassenger> changeTrainOrderPassengerList;
    public List<OrderOptLog> orderOptLogList;

    ///////////////////////////////////////////////////////////////////////////////
    //////// 跑腿改签新增字段 2023/06/13 /////////////////////////////////////////////
    /**
     * 接受非定制 0否 1是 accept_no_vip_custom
     */
    public int onlineBookingAccept;

    /**
     * 定制车厢字符集 carriage_custom
     */
    public String onlineBookingCarriage;

    /**
     * 定制份数 count
     */
    public String onlineBookingCount;

    /**
     * 定制类型 custom_type
     */
    public String onlineBooking;

    /**
     * 选座集合 seat_custom
     */
    public String onlineBookingSeat;

    public String resetReason;//驳回原因
    public String bohuiDate;//驳回原因
    public String payStatus;//支付状态


    // 白板出票定制信息
    /**
     * 定制类型:靠窗
     */
    public String vipTicketWindowSeat;


    /**
     * 定制数量
     */
    public Integer vipTicketWindowSeatCount;


    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer vipTicketWindowSeatAccept;

    /**
     * 定制类型:选过道
     */
    public String vipTicketCorridorSeat;

    /**
     * 定制数量
     */
    public Integer vipTicketCorridorSeatCount;


    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer vipTicketCorridorSeatAccept;

    /**
     * 定制类型:选下铺
     */
    public String vipTicketLowerBerth;


    /**
     * 定制数量
     */
    public Integer vipTicketLowerBerthCount;


    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer vipTicketLowerBerthAccept;

    /**
     * 定制类型:选中下铺
     */
    public String vipTicketMiddleLowerBerth;

    /**
     * 定制数量
     */
    public Integer vipTicketMiddleLowerBerthCount;

    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer vipTicketMiddleLowerBerthAccept;


    /**
     * 定制类型:选中铺
     */
    public String vipTicketMiddleBerth;
    /**
     * 定制数量
     */
    public Integer vipTicketMiddleBerthCount;
    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer vipTicketMiddleBerthAccept;

    /**
     * 定制类型:选上铺
     */
    public String vipTicketUpperBerth;
    /**
     * 定制数量
     */
    public Integer vipTicketUpperBerthCount;
    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer vipTicketUpperBerthAccept;


    /**
     * 定制类型:选车厢
     */
    public String carriage;

    /**
     * 车厢定制内容
     */
    public String carriageCustom;

    /**
     * 定制数量
     */
    public Integer carriageCount;


    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer carriageAccept;

    /**
     * 定制类型:靠车门
     */
    public String nearTheDoor;


    /**
     * 定制数量
     */
    public Integer nearTheDoorCount;

    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer nearTheDoorAccept;

    /**
     * 定制类型:连坐
     */
    public String adjacencySeat;

    /**
     * 定制数量
     */
    public Integer adjacencySeatCount;

    /**
     * 是否接受非定制：是否接受非定制,0不接受,1接受
     */
    public Integer adjacencySeatAccept;

    /**
     * 定制类型:同房间
     */
    public String sameRoom;

    /**
     * 定制数量
     */
    public Integer sameRoomCount;

    /**
     * 是否接受非定制:
     * 不传表示没有此项定制，就不需要sameRoom的定制。
     * 传 1 表示需要sameRoom的定制。
     */
    public Integer sameRoomAccept;

    /*********商旅****/

    public String failReasonAdd;
    public String emergency;
    public String forceMatch;
    public String extendFlags;
    public String interPosition;
    public Integer interPositionCount;
    public Integer interPositionAccept;

    public Float estimateChangePrice;//预估改签结算价金额

    // 紧急标红：0、不紧急；1、原发车紧急；2、改签发车紧急
    private String emergent;

    public String changeSeatType;//余位检查用
    public String checkResult;//检查结果


    public Integer changeRepeatCount;

    public Integer isExport;//是否导出过

    public String specialMark;//特殊标记

    public Integer isGroup;//是否团队票

    public String allocateTime;//分配时间

    public String lookCompanyId;
    public String lookResult;
    public String lookChangeResult;
    public String isLook;

    public String lastFailReason;

    public Integer orderPassengerNum;

    public String handleStatus;//是否已发 1，0

    public ChangeTrainOrder() {


    }

    public List<ChangeTrainOrderPassenger> getChangeTrainOrderPassengerList() {
        if (Utils.isEmpty(this.changeTrainOrderPassengerList)) {
            this.changeTrainOrderPassengerList = new ArrayList<>();
        }
        return changeTrainOrderPassengerList;
    }

    public List<OrderOptLog> getOrderOptLogList() {
        if (Utils.isEmpty(this.orderOptLogList)) {
            this.orderOptLogList = new ArrayList<>();
        }
        return orderOptLogList;
    }


    public void handleChangeTicketType() {
        DateTime change = DateUtil.parseDate(this.changeFromDateTime);
        DateTime origin = DateUtil.parseDate(this.originalFromDateTime);

        if (!this.changeToStation.equals(this.originalToStation)) {
            this.changeTicketType = ChangeTicketTypeEnum.TO_STATION_CHANGE.getCode();
            return;
        } else if (!this.changeTrainCode.equals(this.originalTrainCode) && !change.equals(origin)) {
            this.changeTicketType = ChangeTicketTypeEnum.TRAIN_FROM_TIME_CHANGE.getCode();
            return;
        }
        for (ChangeTrainOrderPassenger changeTrainOrderPassenger : this.changeTrainOrderPassengerList) {
            if (!changeTrainOrderPassenger.getOriginalSeatTypeCode().equals(changeTrainOrderPassenger.changeSeatTypeCode)) {
                this.changeTicketType = ChangeTicketTypeEnum.SEAT_TYPE_CHANGE.getCode();
                return;
            }
        }

        if (!this.changeTrainCode.equals(this.originalTrainCode)) {
            this.changeTicketType = ChangeTicketTypeEnum.TRAIN_CHANGE.getCode();
        } else if (!change.equals(origin)) {
            this.changeTicketType = ChangeTicketTypeEnum.DATE_CHANGE.getCode();
        }
    }
}
