package com.tuigai.tuigai_tongcheng_api.utils;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.tuigai.tuigai_tongcheng_api.config.TuiGaiConfig;
import com.tuigai.tuigai_tongcheng_api.model.ChangeTrainOrder;
import com.tuigai.tuigai_tongcheng_api.model.ChangeTrainOrderPassenger;


import java.util.List;
import java.util.stream.Collectors;

public class ChangeOrderUtils {
    public static JSONObject generateParam(ChangeTrainOrder changeTrainOrder, List<ChangeTrainOrderPassenger> changeTrainOrderPassengerList) {
        TuiGaiConfig tuiGaiConfig = SpringContextUtil.getBean(TuiGaiConfig.class);

        JSONObject param = new JSONObject();
        param.put("account", tuiGaiConfig.getAccount());
        param.put("secretKey", tuiGaiConfig.getSecretKey());
        param.put("timestamp", DateUtil.now());
        param.put("sign", "");

        JSONObject data = new JSONObject();
        data.put("platformCode", changeTrainOrder.outId);
        data.put("orderCode", "");
        data.put("platform", changeTrainOrder.changeFromStation + "-" + changeTrainOrder.changeToStation);
        data.put("departureDate", changeTrainOrder.originalFromDateTime);
        data.put("trainNum", changeTrainOrder.originalTrainCode);
        data.put("primaryDepartmentTime", changeTrainOrder.changeFromDateTime);
        data.put("primaryTrainNum", changeTrainOrder.changeTrainCode);
        data.put("primaryTicketPrice", changeTrainOrder.ticketPriceAll);
        data.put("primarySeat", changeTrainOrder.changeSeatType);

        List<JSONObject> passengerList = changeTrainOrderPassengerList.stream().map((e -> {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("passengerName", e.getPassengerName());
            jsonObject.put("idCard", e.getCertificateNo());
            jsonObject.put("seatRemark", "");
            return jsonObject;
        })).collect(Collectors.toList());
        data.put("passenger", passengerList);
        param.put("data", data);

        return param;
    }
}
