package com.tuigai.tuigai_tongcheng_api.utils;


import java.util.HashMap;
import java.util.Map;

public class OrderStatus {

    /**
     * 1.待分配 2待出票 3.已出票 4.已取消 5.已作废 6.已出库 7.已支付，8.验证中,9、其他
     * 11。占座中，12.占座失败，13、占座成功，14.支付中，（7、已支付）16支付失败，17、获取票号
     *
     * '1.未出票 2出票失败 3.已出票 4.已取消 5.已作废 6.已出库 7.已支付，8.验证中,'
     */
    /**
     * 支付状态 21支付成功有票号了，16，支付失败，不处理了，18，支付未知，请检查，不处理了，20.支付成功无票号
     * 支付状态  21, 直接修改为出票完成，回填票号
     * 人工重新支付，需要判断，状态为  orderStatus  16 失败  18 未知)
     */
    public static final int DAIFENPEI = 1;
    public static final int DAICHUPIAO = 2;
    public static final int YICHUPIAO = 3;
    public static final int YIQUXIAO = 4;
    public static final int YIZUOFEI = 5;

    //自动出票 已取消
    public static final int YIQUXIAOCALL = 0;
    //自动出票 取消失败
    public static final int YIQUXIAOFail = -1;
    //取消中
    public static final int QUXIAOZHONG = -2;

    public static final int ZHANZUOZHONG = 11;//占座中
    public static final int ZHANZUOSHIBAI = 12;//占座失败
    public static final int ZHANZUOCHENGGONG = 13;//占座成功

    public static final int ORDERDAIZHIFU = 14; //待支付
    public static final int ORDERYIZHIFU = 63;//已支付
    public static final int ORDERZHIFUFAIL = 64;//支付失败
    public static final int ORDERZHIFUERROR = 65;//支付异常
    public static final int ORDER_YIZHIFU_WEIHEDUI = 66;//支付成功未核对
    public static final int ORDER_YIZHIFU_YIHEDUI = 67;//支付成功以核对

    public static final String YIQUXIAOCALL_DESC = "已取消";
    public static final String YIQUXIAOFail_DESC = "取消失败";
    public static final String QUXIAOZHONG_DESC = "取消异常";

    public static final int YICHUPIAODAIQUEREN = 31;
    public static final int YICHUPIAOHUITIANSHIBAI = 32;
    public static final int SUODANSHIBAI = 41;
    public static final int DAITUIPIAO = 42;
    public static final int TUIPIAOZHONGAUTO = 46;
    public static final int TUIPIAOCHENGGONG = 43;
    public static final int TUIPIAOSHIBAI = 44;
    public static final int TUIPIAOYICHANG = 45;
    public static final int DAICHANGE = 50;//待改签
    public static final int CHANGESHIBAI = 51;//改签失败
    public static final int CHANGECHENGGONG = 52;//改签成功
    public static final String DAIFENPEI_DESC = "待分配";
    public static final String DAICHUPIAO_DESC = "待出票";

    public static final String ZHANZUOSHIBAI_DESC = "占座失败";
    public static final String ZHANZUOCHENGGONG_DESC = "占座成功";
    public static final String ORDERDAIZHIFU_DESC = "待支付";
    public static final String ORDERYIZHIFU_DESC = "已支付";
    public static final String ORDERZHIFUFAIL_DESC = "支付失败";
    public static final String ORDERZHIFUERROR_DESC = "支付异常";

    public static final String YICHUPIAO_DESC = "出票成功";
    public static final String YIQUXIAO_DESC = "出票失败";
    public static final String YIZUOFEI_DESC = "票点驳回";
    public static final String YICHUPIAODAIQUEREN_DESC = "已出票待继续";
    public static final String YICHUPIAOHUITIANSHIBAI_DESC = "已出票回填失败";
    public static final String LIRUNLANJIE = "订单利润拦截";
    public static final String DINGDANBUNENGZHIFU = "请检查订单状态；锁单人是否为system，或者该出票方式是否允许自动支付！";
    public static final String SUODANSHIBAI_DESC = "锁单失败";
    public static final String DAITUIPIAO_DESC = "待退票";
    public static final String TUIPIAOZHONGAUTO_DESC = "退票中";
    public static final String TUIPIAOCHENGGONG_DESC = "退票成功";
    public static final String TUIPIAOSHIBAI_DESC = "退票失败";
    public static final String DAICHANGE_DESC = "待改签";
    public static final String CHANGESHIBAI_DESC = "改签失败";
    public static final String CHANGECHENGGONG_DESC = "改签成功";
    public static final String TUIPIAOYICHANG_DESC = "退票暂存";

    public static final String MEITUAN = "meituan";
    public static final String TAOBAO = "taobao";

    public static final String YSL = "YSL";
    // 胜意
    public static final String SHY = "SHY";


    //退票异常类型
    // 1:"退票特殊异常", 0:"正常", 2:"重复退票单", 3:"异常并且重复退票",4:"重复退票已退款"
    public static final String RETURNSPECIAL_ZHENGCHANG = "0";
    public static final String RETURNSPECIAL_TESUYICHANG = "1";
    public static final String RETURNSPECIAL_CHONGFUTUIPIAO = "2";
    public static final String RETURNSPECIAL_YICHANGBINGCHONGFU = "3";
    public static final String RETURNSPECIAL_CHOGFUYITUIKUAN = "4";
    public static final String RETURNSPECIAL_YITUIKUAN = "5";


    //退票订单类型
    //1:"自出退票", 2:"待退订单", 3:"12306退票订单", 4:"高改低退差订单",5:"本人退票"
    public static final String RETURNORDER_TYPE_ZICHU = "1";
    public static final String RETURNORDER_TYPE_DAITUI = "2";
    public static final String RETURNORDER_TYPE_12306TUI = "3";
    public static final String RETURNORDER_TYPE_GAOGAIDI = "4";
    public static final String RETURNORDER_TYPE_BENRENTUI = "5";
    public static final String RETURNORDER_TYPE_ZANCUN = "6";


    public OrderStatus(int orderStatus, String orderStatusDesc) {
        this.orderStatus = orderStatus;
        this.orderStatusDesc = orderStatusDesc;
    }

    public static String getOrderStatusDesc(int status) {
        switch (status) {
            case DAICHUPIAO:
                return DAICHUPIAO_DESC;
            case DAIFENPEI:
                return DAIFENPEI_DESC;
            case YICHUPIAO:
                return YICHUPIAO_DESC;
            case YIQUXIAO:
                return YIQUXIAO_DESC;
            case YIZUOFEI:
                return YIZUOFEI_DESC;
            case SUODANSHIBAI:
                return SUODANSHIBAI_DESC;
            case TUIPIAOCHENGGONG:
                return TUIPIAOCHENGGONG_DESC;
            case TUIPIAOSHIBAI:
                return TUIPIAOSHIBAI_DESC;
            case TUIPIAOYICHANG:
                return TUIPIAOYICHANG_DESC;
            case DAICHANGE:
                return DAICHANGE_DESC;
            case CHANGESHIBAI:
                return CHANGESHIBAI_DESC;
            case CHANGECHENGGONG:
                return CHANGECHENGGONG_DESC;
            case ZHANZUOSHIBAI:
                return ZHANZUOSHIBAI_DESC;
            case ZHANZUOCHENGGONG:
                return ZHANZUOCHENGGONG_DESC;
            case ORDERDAIZHIFU:
                return ORDERDAIZHIFU_DESC;
            case ORDERYIZHIFU:
                return ORDERYIZHIFU_DESC;
            case ORDERZHIFUFAIL:
                return ORDERZHIFUFAIL_DESC;
            case ORDERZHIFUERROR:
                return ORDERZHIFUERROR_DESC;
            default:
                return null;
        }
    }

    public int orderStatus;
    public String orderStatusDesc;

    public OrderStatus(OrderStatus orderStatus) {
        this.orderStatus = orderStatus.orderStatus;
        this.orderStatusDesc = orderStatus.orderStatusDesc;
    }

    public static Map<String, String> getReturnStatusMap() {
        Map<String, String> map = new HashMap<>();
        map.put("42", "待退票");
        map.put("43", "退票成功");
        map.put("44", "退票失败");
        map.put("45", "退票异常");

        return map;
    }

    /**
     * 退票异常集合
     *
     * @return
     */
    public static Map<String, String> getReturnSpecialMap() {
        Map<String, String> map = new HashMap<>();
        map.put("0", "正常");
        map.put("1", "退票特殊异常");
        map.put("2", "重复退票单");
        map.put("3", "异常并且重复退票");
        map.put("4", "重复退票已退款");
        map.put("5", "已退款");
        return map;
    }

    public static Map<String, String> getReturnTypeMap() {
        Map<String, String> map = new HashMap<>();
        map.put("1", "自出退票");
        map.put("2", "代退订单");
        map.put("3", "12306退票订单");
        map.put("4", "高改低退差订单");
        map.put("5", "本人退票不退款");
        return map;
    }

    public static Map<String, String> getchangeTypeMap() {
        Map<String, String> map = new HashMap<>(); //0: '低改高', 1: '平改' , 2: '高改低'
        map.put("0", "低改高");
        map.put("1", "平改");
        map.put("2", "高改低");
        return map;
    }


}
